// Command line arguments

enum {
  ARG_PRIORITY,
  ARG_POPKEY,
  ARG_POPUP,
  ARG_BLANKSCREEN,
  ARG_SAVESCREEN,
  ARG_FRACTAL,
  ARG_COLOUR,
  ARG_DISPLAYMODE,
  ARG_DEPTH,
  ARG_SCREENTIMEOUT,
  ARG_PATTERNTIMEOUT,
  ARG_MAXRECURSION,
  ARG_MAXDOTS,

  ARGCOUNT
};

// Hotkey IDs

enum {
  POP_WINDOW,
  BLANK_SCREEN,
  SAVE_SCREEN
};

// Error codes

enum {
  ERR_SystemError  = 30000, // CBERR_SYSERR
  ERR_Duplicate,            // CBERR_DUP,
  ERR_Version,              // CBERR_VERSION,

  ERR_BadFilter = 31000,    // COERR_BADFILTER,
  ERR_BadType,              // COERR_BADTYPE

  ERR_NoIntuition = 32000,  // intuition.library didn't open
  ERR_NoGfx,                // graphics.library didn't open
  ERR_NoAsl,                // asl.library didn't open
  ERR_NoCommodities,        // commodities.library didn't open
  ERR_NoCommoditiesIFace,   // commodities main interface didn't open
  ERR_NoUtility,            // utility.library didn't open
  ERR_NoUtilityIFace,       // utility main interface didn't open
  ERR_NoIcon,               // icon.library didn't open
  ERR_ScreenModeRequest,    // Couldn't allocate ScreenModeRequester
  ERR_NoColours,            // Couldn't allocate colour table
  ERR_NoPointer,            // Couldn't create transparent pointer
  ERR_NoControlProcess,     // Couldn't create control process
  ERR_NoMsgPort,            // Couldn't create msgport
  ERR_NoWindow,             // Couldn't open window
  ERR_NoKeymap,             // Couldn't open keymap.library
  ERR_NoKeymapIFace,        // Couldn't open keymap main interface
  ERR_NoGTLayout,           // Couldn't open gtlayout.library
};

// Fractal types

enum {
  FRACTAL_REAL_PLANE,
  FRACTAL_COSMIC_FLAME,
  FRACTAL_RANDOM
};

// Colour modes

enum {
  COLOUR_CYCLE,
  COLOUR_STATIC
};

// Some useful signals

#define SIG_FINISH     SIGBREAKF_CTRL_E
#define SIG_BREAK      SIGBREAKF_CTRL_C
#define SIG_CHANGE     SIGBREAKF_CTRL_D
#define SIG_CYCLE      SIGBREAKF_CTRL_E
#define SIG_START      SIGBREAKF_CTRL_F
#define SIG_REFRESH    SIG_START
#define SIG_WAKEUP     SIGBREAKF_CTRL_F
#define SIG_HANDSHAKE  SIGF_SINGLE

// A 96 bit colour entry

typedef struct ColourEntry {
  ULONG Red,
        Green,
        Blue;
} ColourEntry;

// A table of colour entries, ready for LoadRGB32()

typedef struct ColourTable {
  WORD NumColours,
       FirstColour;
  ColourEntry Entry[1];
  ULONG Terminator;
} ColourTable;

